## xtpcpp 0.4.51

=== CMakeLists.txt ===
# CMake script for C++ X!TandemPipeline
# Author: Olivier Langella
# Created: 05/06/2015
# Use git to check for contributions by other authors.

# Global parameters
CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
PROJECT(xtpcpp CXX)

set(XTPCPP_VERSION_MAJOR "0")
set(XTPCPP_VERSION_MINOR "4")
set(XTPCPP_VERSION_PATCH "51")
set(XTPCPP_VERSION "${XTPCPP_VERSION_MAJOR}.${XTPCPP_VERSION_MINOR}.${XTPCPP_VERSION_PATCH}")
set(VERSION 0.4.51)

# Set additional project information
set(COMPANY "pappso.org")
set(COPYRIGHT "Copyright (c) 2022 PAPPSO. Licensed under GPLv3+")
set(IDENTIFIER "org.pappso")


#depending on libpappsomspp version :
set(LIBPAPPSOMSPP_VERSION "0.8.48")
set(LIBRDATA_VERSION "0~20210223+git-85757dc6")


# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)

message("\n${BoldRed}Configuring build for project ${CMAKE_PROJECT_NAME}${ColourReset}\n")

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)
# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)

if(WARN_AS_ERROR)
  message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
  add_definitions(-Werror)
endif()

message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(MXE)
  # Run the following cmake command line:
  # x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
  #include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
  include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)

  # Set the name to the systemUname variable because in this situation that name
  # is not found, it it passed as a flag in the command line.
  set(systemUname "mxe")

elseif(UNIX AND NOT APPLE)
  # Run the following cmake command line:
  # cmake -DBUILD_USER_MANUAL=1 -DCMAKE_BUILD_TYPE=Debug
  # If the libraries to be used are local and not system-wide add
  # -DLOCAL_DEV=1

  # On UNIX, the libpappsomspp and libpappsomspp-widget libs
  # need to be installed and they ship the PappsoMSppConfig.cmake
  # config file.

  # However, when developing both libs and this program, we need to be able to
  # load the libs from their dev/build directory without relying on the system
  # libs.
  if(LOCAL_DEV)

    # The development should use the locally built libs.
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain-local.cmake)
  else()

    # Use the system-wide libraries.
    include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

  endif()

  message(STATUS "Include dir for PappsoMSpp is at: ${PappsoMSpp_INCLUDE_DIRS}")
  message(STATUS "PappsoMSpp and PappsoMSppWidget were found at:
  \t ${PappsoMSpp_LIBRARIES} and ${PappsoMSppWidget_LIBRARIES}")

elseif(WIN64)
  # Run the following cmake command line:
  # cmake -DBUILD_USER_MANUAL=0 -DCMAKE_BUILD_TYPE=Release ../development

  include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)

elseif(APPLE)
  # Run the following cmake command line:
  # cmake -DBUILD_USER_MANUAL=0 -DCMAKE_BUILD_TYPE=Release ../development

  include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${CMAKE_PROJECT_NAME}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SystemUname}${ColourReset}")
message("")



#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

# Gee, do not set that to default!
# set(MAKE_TEST 1)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
    "Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
    FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
  message(STATUS "Compiling in release mode.")
  add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
  message(STATUS "Compiling in debug mode with BUILD_TESTING: ${BUILD_TESTING}.")
  message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
  add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  message(STATUS "Compiling in release with debug info mode.")
endif( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")

# Automate the production of correctly-versioned d/control file.
configure_file (${CMAKE_SOURCE_DIR}/debian/control.cmake.in ${CMAKE_SOURCE_DIR}/debian/control @ONLY)


set(SOFTWARE_NAME "X!TandemPipeline")

set(BUILD_SYSTEM_NAME "${CMAKE_SYSTEM_NAME}")

# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
# standard install location
if(CMAKE_INSTALL_PREFIX)
  set(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
endif(CMAKE_INSTALL_PREFIX)

# Subdirectories
add_subdirectory(src)
add_subdirectory(doc)

if(UNIX)

  # Conditional addition of the test directory.
  if(BUILD_TESTING)

    enable_testing()
    include(CTest)
    add_subdirectory(tests)

  endif(BUILD_TESTING)

  # Doxygen
  find_package(Doxygen)
  if(DOXYGEN_FOUND)
    add_custom_target(apidoc cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-build
      COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-build
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-build
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
    add_custom_target(apidoc-stable cp Doxyfile ${CMAKE_BINARY_DIR}/Doxyfile-stable
      COMMAND echo "OUTPUT_DIRECTORY=${CMAKE_BINARY_DIR}" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
      COMMAND echo "HTML_HEADER=header.html" >> ${CMAKE_BINARY_DIR}/Doxyfile-stable
      COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile-stable
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
  endif(DOXYGEN_FOUND)
endif(UNIX)
# Packager
set(CPACK_PACKAGE_NAME "xtpcpp")
set(CPACK_PACKAGE_VENDOR "PAPPSO Development Team")
set(CPACK_PACKAGE_VERSION "${XTPCPP_VERSION}")
set(CPACK_PACKAGE_VERSION_MAJOR "${XTPCPP_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${XTPCPP_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${XTPCPP_VERSION_PATCH}")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "protein inference tool")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
set(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
set(CPACK_RESOURCE_FILE_INSTALL "${CMAKE_SOURCE_DIR}/INSTALL")
set(CPACK_SOURCE_GENERATOR "TGZ")
set(CPACK_SOURCE_IGNORE_FILES
  "CMakeFiles"
  "Makefile"
  "_CPack_Packages"
  "CMakeCache.txt"
  ".*\\\\.git"
  ".*\\\\.gz"
  ".*\\\\.deb"
  ".*\\\\.rpm"
  ".*\\\\.dmg"
  ".*\\\\.xpip"
  ".*\\\\..*\\\\.swp"
  "src/\\\\..*"
  "src/libbpp*"
  "debian/tmp"
  "debian/libbpp.*/"
  "debian/libbpp.*\\\\.so.*"
  "debian/libbpp.*\\\\.a"
  "debian/libbpp.*\\\\.substvars"
  "debian/libbpp.*\\\\.debhelper"
  "debian/debhelper\\\\.log"
  "build/"
  "cbuild/"
  "wbuild/"
  "Core.tag"
  "Testing"
  "build-stamp"
  "install_manifest.txt"
  "DartConfiguration.tcl"
  ${CPACK_SOURCE_IGNORE_FILES}
  )



#dch -Djessie "message"
#cmake ..
#make deb
# scp xtpcpp* tandem* proteus.moulon.inra.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default
#
#  debuild -S -sa
# dput -f olivier-langella *changes

if(MACOS)
  SET(CPACK_GENERATOR "Bundle")
endif()

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set(CPACK_DEBSOURCE_PACKAGE_FILE_NAME "lib${CMAKE_PROJECT_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.orig")
iNCLUDE(CPack)

#This adds the 'dist' target
add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
# 'clean' is not (yet) a first class target. However, we need to clean the directories before building the sources:
if("${CMAKE_GENERATOR}" MATCHES "Make")
  add_custom_target(make_clean
    COMMAND ${CMAKE_MAKE_PROGRAM} clean
    WORKING_DIRECTORY ${CMAKE_CURRENT_DIR}
    )
  Add_dependencies(dist make_clean)
endif()

if(UNIX)
  #This creates deb packages:

  add_custom_target(targz
    cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz ${CPACK_PACKAGE_NAME}-${XTPCPP_VERSION}.tar.gz && ln -s ${CPACK_PACKAGE_NAME}-${XTPCPP_VERSION}.tar.gz ${CPACK_PACKAGE_NAME}_${XTPCPP_VERSION}.orig.tar.gz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating .tar.gz" VERBATIM
    )


  add_custom_target(deb
    cd ${CPACK_PACKAGE_NAME}-${XTPCPP_VERSION} && dpkg-buildpackage -B
    DEPENDS targz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating Debian package" VERBATIM
    )

  add_custom_target(deball
    cd ${CPACK_PACKAGE_NAME}-${XTPCPP_VERSION} && dpkg-buildpackage
    DEPENDS targz
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "Creating Debian package" VERBATIM
    )

  file(GLOB changesdebs "${CMAKE_BINARY_DIR}/${CPACK_PACKAGE_NAME}_*.dsc")

  foreach(libfile ${changesdebs})
    SET(changesdeb "${libfile}")
  endforeach(libfile)

  message ("changes debian file : ${changesdeb}")
  #lintian -IEi --pedantic tandem-mass_2013.06.15-1_amd64.changes
  add_custom_target(lintian
    lintian -IEi --pedantic ${changesdeb}
    DEPENDS deb
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMENT "lintian check" VERBATIM
    )

endif(UNIX)

set(ctest_update_type GIT)
set(update_command "GIT")
set(UPDATE_OPTIONS "")

configure_file (${CMAKE_SOURCE_DIR}/templates/share/applications/xtpcpp.desktop.cmake ${CMAKE_BINARY_DIR}/templates/share/applications/xtpcpp.desktop)

configure_file (${CMAKE_SOURCE_DIR}/win64/xtpcpp-mingw64-win7+.iss.cmake ${CMAKE_SOURCE_DIR}/win64/xtpcpp-mingw64-win7+.iss)

configure_file (${CMAKE_SOURCE_DIR}/win64/xtpcpp-mxe.iss.cmake ${CMAKE_SOURCE_DIR}/win64/xtpcpp-mxe.iss)

install(FILES ${CMAKE_BINARY_DIR}/templates/share/applications/xtpcpp.desktop DESTINATION share/applications)


if(NOT APPLE)

  # We want to install the binary arch-dependent target in
  # specific situations. To have proper control, we define the arch
  # component.
  install(TARGETS ${TARGET}
    RUNTIME
    COMPONENT arch
    DESTINATION ${BIN_DIR})

endif()

configure_file(${CMAKE_SOURCE_DIR}/src/resources/xtandempipeline_icon.svg ${CMAKE_BINARY_DIR}/src/resources/xtpcpp.svg COPYONLY)

install(FILES ${CMAKE_BINARY_DIR}/src/resources/xtpcpp.svg DESTINATION share/icons/hicolor/scalable/apps)

=== doc/CMakeLists.txt ===
message("")
message(STATUS "${BoldGreen}Starting configuration for the doc material for ${CMAKE_PROJECT_NAME} ${ColourReset}")
message("")

# The UNIX man pages
if(UNIX AND NOT APPLE)

	message(STATUS "Going to generate the man pages.")

	execute_process(COMMAND docbook-to-man ${CMAKE_PROJECT_NAME}.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})
	execute_process(COMMAND docbook-to-man tandemwrapper.xml
		OUTPUT_FILE	${CMAKE_BINARY_DIR}/tandemwrapper.1
		WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR})

endif(UNIX AND NOT APPLE)


###############
# install stuff

# The history and licence files.

message("Installing the doc files in ${DOC_DIR}")

# The man page.
if(UNIX AND NOT APPLE)
	install(FILES ${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}.1
		${CMAKE_BINARY_DIR}/${CMAKE_PROJECT_NAME}.1
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
    install(FILES ${CMAKE_BINARY_DIR}/tandemwrapper.1
		${CMAKE_BINARY_DIR}/tandemwrapper.1
		DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1)
endif()


#############################################################
###########################
# BUILD OF THE USER MANUALS

if(BUILD_USER_MANUAL)
	add_subdirectory(user-manual)
endif()


message("")
message(STATUS "${BoldGreen}Finished configuration of the doc material.${ColourReset}")
message("")

=== src/CMakeLists.txt ===
# CMake script for xtpcpp
# Author: Olivier Langella
# Created: 03/03/2015


SET(xtpcpp_RCCS xtpcpp.qrc)
# Appeler automatique le moc quand nécessaire
#SET(CMAKE_AUTOMOC ON)
# Les fichiers générés par le moc sont générés dans le dossier bin, dire à CMake de toujours 	
# inclure les entêtes de ce dossier
#SET(CMAKE_INCLUDE_CURRENT_DIR ON)


find_package( Qt5 COMPONENTS Core Gui Svg Xml PrintSupport Sql Network Concurrent REQUIRED )
qt5_add_resources(xtpcpp_RCC_SRCS ${xtpcpp_RCCS})


find_package(ZLIB REQUIRED)


if(QCustomPlot_FOUND)
  message("QCustomPlot_INCLUDES found ${QCustomPlot_INCLUDE_DIRS}")
else(QCustomPlot_FOUND)
  find_package( QCustomPlot REQUIRED )
endif(QCustomPlot_FOUND)


if(RData_FOUND)
  message("RData_INCLUDE_DIRS found ${RData_INCLUDE_DIRS}")
  message("RData_LIBRARIES found ${RData_LIBRARIES}")
else(RData_FOUND)
  find_package(RData REQUIRED)
endif(RData_FOUND)

if(Grantlee5_FOUND)
else(Grantlee5_FOUND)
  message("Grantlee library not found")
endif(Grantlee5_FOUND)


#sudo apt-get install libpappsomspp-dev
if(PappsoMSpp_FOUND)
else(PappsoMSpp_FOUND)
  message("PAPPSOms++ library not found")
  message("did you apt-get install libpappsomspp-dev ?")
endif(PappsoMSpp_FOUND)


if(PappsoMSppWidget_FOUND)
else(PappsoMSppWidget_FOUND)
  message("PAPPSOms++ widget library not found")
  message("did you apt-get install libpappsomspp-widget-dev ?")
endif(PappsoMSppWidget_FOUND)

message("PAPPSOms++ library : ${PappsoMSpp_LIBRARIES}")


configure_file(${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)

# File list
set(CPP_FILES
  core/automaticfilterparameters.cpp
  core/condor_process/condorprocess.cpp
  core/condor_process/condorqueueparser.cpp
  core/identificationgroup.cpp
  core/identification_sources/identificationdatasource.cpp
  core/identification_sources/identificationmascotdatfile.cpp
  core/identification_sources/identificationmzidentmlfile.cpp
  core/identification_sources/identificationpepxmlfile.cpp
  core/identification_sources/identificationpwizfile.cpp
  core/identification_sources/identificationxtandemfile.cpp
  core/labeling/label.cpp
  core/labeling/labelingmethod.cpp
  core/masschroq_run/masschroqbatchprocess.cpp
  core/masschroq_run/masschroqcondorprocess.cpp
  core/masschroq_run/masschroqfileparameters.cpp
  core/mcqr/mcqrexperiment.cpp
  core/qvalue/computeqvalues.cpp
  core/tandem_run/tandembatchprocess.cpp
  core/tandem_run/tandemcondorprocess.cpp
  core/tandem_run/tandemparameters.cpp
  core/alignmentgroup.cpp
  core/msrun.cpp
  core/peptideevidence.cpp
  core/peptidematch.cpp
  core/peptidextp.cpp
  core/project.cpp
  core/proteinmatch.cpp
  core/proteinxtp.cpp
  core/sequencedatabase.cpp
  files/fastafile.cpp
  files/tandemparametersfile.cpp
  files/xpipfile.cpp
  grouping/groupingexperiment.cpp
  grouping/ptm/ptmacetylation.cpp
  grouping/ptm/ptminterface.cpp
  grouping/groupinggroup.cpp
  grouping/groupingpeptidemass.cpp
  grouping/ptm/ptmgroupingexperiment.cpp
  grouping/ptm/ptmisland.cpp
  grouping/ptm/ptmislandgroup.cpp
  grouping/ptm/ptmislandsubgroup.cpp
  grouping/ptm/ptmphospho.cpp
  grouping/ptm/ptmsamplescan.cpp
  input/mascot/mascotdatparser.cpp
  input/mascot/mimeparser.cpp
  input/mzidentml/msrunsaxhandler.cpp
  input/mzidentml/mzidentmlsaxhandler.cpp
  input/tandem/tandeminfoparser.cpp
  input/tandem/tandemparamparser.cpp
  #  input/identificationpwizreader.cpp
  input/metadataodshandler.cpp
  input/pepxmlsaxhandler.cpp
  input/xpipsaxhandler.cpp
  input/xtandemsaxhandler.cpp
  input/xtpxpipsaxhandler.cpp
  output/mcqr/mcqrdata.cpp
  output/mcqr/mcqrscprotein.cpp
  output/mcqr/mcqrscpeptide.cpp
  output/ods/mass_delta/validmassdeltasheet.cpp
  output/ods/mass_delta/notvalidmassdeltasheet.cpp
  output/ods/ptm/ptmislandsheet.cpp
  output/ods/ptm/ptmspectrasheet.cpp
  output/ods/comparbasesheet.cpp
  output/ods/comparspecificspectrasheet.cpp
  output/ods/comparspectrabypeptide.cpp
  output/ods/comparspectrasheet.cpp
  output/ods/groupingsheet.cpp
  output/ods/infosheet.cpp
  output/ods/mcqrmetadatasheet.cpp
  output/ods/odsexport.cpp
  output/ods/peptidepossheet.cpp
  output/ods/peptidesheet.cpp
  output/ods/proteinsheet.cpp
  output/ods/qvaluessheet.cpp
  output/ods/samplesheet.cpp
  output/ods/simplesheet.cpp
  output/ods/spectrasheet.cpp
  output/ods/spectrasheetall.cpp
  output/ods/xicareasheet.cpp
  output/ods/xicinfosheet.cpp
  output/exportfastafile.cpp
  output/masschroqml.cpp
  output/masschroqprm.cpp
  output/mcqrspectralcount.cpp
  output/proticdbml.cpp
  output/xpip.cpp
  utils/fastafilestore.cpp
  utils/identificationdatasourcestore.cpp
  utils/groupstore.cpp
  utils/httpversion.cpp
  utils/msrunstatisticshandler.cpp
  utils/msrunstore.cpp
  utils/peptideevidencestore.cpp
  utils/peptidestore.cpp
  utils/proteinstore.cpp
  utils/ptmbuilder.cpp
  utils/utils.cpp
  )

# we need this to be able to include headers produced by uic in our code
#(CMAKE_BINARY_DIR holds a path to the build directory, while INCLUDE_DIRECTORIES() works just like INCLUDEPATH from qmake)

set(XTPCPP_SRCS
  ./core/mcqr/mcqrqprocess.cpp
  ./gui/about_dialog/aboutdialog.cpp
  ./gui/choose_modification_dialog/choosemodificationdialog.cpp
  ./gui/edit/deepprot_gui/modification_browser/modificationbrowser.cpp
  ./gui/edit/deepprot_gui/deepprotgui.cpp
  ./gui/edit/edit_label_methods/editlabelmethods.cpp
  ./gui/edit/edit_modifications/editmodifications.cpp
  ./gui/edit/edit_settings/editsettings.cpp
  ./gui/edit/edit_tandem_preset_dialog/edittandempresetdialog.cpp
  ./gui/export/export_spreadsheet_dialog/exportspreadsheetdialog.cpp
  ./gui/load_results_dialog/loadresultsdialog.cpp
  ./gui/lists/ms_identification_run_list_view/msidentificationlistwindow.cpp
  ./gui/lists/ms_identification_run_list_view/msidentificationtablemodel.cpp
  ./gui/lists/ms_identification_run_list_view/msidentificationtableproxymodel.cpp
  ./gui/lists/ms_identification_run_list_view/ms_identification_worker/msidlistworkerstatus.cpp
  ./gui/lists/ms_identification_run_list_view/engine_detail_view/enginedetailwindow.cpp
  ./gui/masschroq_run_dialog/masschroqrundialog.cpp
  ./gui/mcqr_param_dialog/mcqrparamallquantidialog.cpp
  ./gui/mcqr_run_view/mcqrparamwidget.cpp
  ./gui/mcqr_run_view/mcqrrunview.cpp
  ./gui/mcqr_run_view/mcqr_sds_widget/mcqrsdswidget.cpp
  ./gui/mcqr_run_view/mcqr_sds_xic_widget/mcqrsdsxicwidget.cpp
  ./gui/mainwindow.cpp
  ./gui/peptide_detail_view/peptidewindow.cpp
  ./gui/peptide_list_view/peptidelistwindow.cpp
  ./gui/peptide_list_view/peptidetablemodel.cpp
  ./gui/peptide_list_view/peptidetableproxymodel.cpp
  ./gui/project_view/identification_group_widget/identificationgroupwidget.cpp
  ./gui/project_view/projectwindow.cpp
  ./gui/protein_view/proteinwindow.cpp
  ./gui/protein_list_view/proteinlistwindow.cpp
  ./gui/protein_list_view/proteintablemodel.cpp
  ./gui/protein_list_view/proteintableproxymodel.cpp
  ./gui/ptm_island_list_view/ptmislandlistwindow.cpp
  ./gui/ptm_island_list_view/ptmislandtablemodel.cpp
  ./gui/ptm_island_list_view/ptmislandproxymodel.cpp
  ./gui/ptm_peptide_list_view/ptmpeptidelistwindow.cpp
  ./gui/ptm_peptide_list_view/ptmpeptidetablemodel.cpp
  ./gui/ptm_peptide_list_view/ptmpeptidetableproxymodel.cpp
  ./gui/ptm_peptide_list_view/ptmsequencedelegate.cpp
  ./gui/tandem_run_dialog/tandemrundialog.cpp
  ./gui/waiting_message_dialog/waitingmessagedialog.cpp
  ./gui/widgets/Alignment_group_menu/alignmentgroupmenu.cpp
  ./gui/widgets/automatic_filter_widget/automaticfilterwidget.cpp
  ./gui/widgets/engines_view/xtandemparamwidget.cpp
  ./gui/widgets/engines_view/noengineparamwidget.cpp
  ./gui/widgets/qcp_massdelta/massdeltawidget.cpp
  ./gui/widgets/qcp_massdelta/qcpmassdelta.cpp
  ./gui/widgets/contaminant_widget/contaminantwidget.cpp
  ./gui/widgets/decoy_widget/decoywidget.cpp
  ./gui/widgets/xic_extraction_method_widget/xicextractionmethodwidget.cpp
  ./gui/widgets/massitemdelegate.cpp
  ./gui/xic_view/xic_box/xicbox.cpp
  ./gui/xic_view/xic_widgets/zivydialog.cpp
  ./gui/xic_view/xic_widgets/zivywidget.cpp
  ./gui/xic_view/xic_widgets/xicexportparam.cpp
  ./gui/xic_view/xicwindow.cpp
  ./gui/xic_view/xicworkerthread.cpp
  ./gui/workerthread.cpp
  ./utils/workmonitor.cpp
  )

set(GUI_UIS
  ./gui/about_dialog/about_dialog.ui
  ./gui/choose_modification_dialog/choose_modification_dialog.ui
  ./gui/edit/deepprot_gui/modification_browser/uimodificationbrowser.ui
  ./gui/edit/deepprot_gui/deepprot_gui.ui
  ./gui/edit/edit_alignment_param/masschroq_param_view.ui
  ./gui/edit/edit_label_methods/edit_label_methods.ui
  ./gui/edit/edit_modifications/edit_modifications.ui
  ./gui/edit/edit_settings/edit_settings.ui
  ./gui/edit/edit_tandem_preset_dialog/edit_tandem_preset_dialog.ui
  ./gui/export/export_spreadsheet_dialog/export_spreadsheet_dialog.ui
  ./gui/lists/ms_identification_run_list_view/ms_identification_run_view.ui
  ./gui/lists/ms_identification_run_list_view/engine_detail_view/engine_detail_view.ui
  ./gui/load_results_dialog/load_results_dialog.ui
  ./gui/masschroq_run_dialog/masschroq_run_dialog.ui
  ./gui/mcqr_param_dialog/mcqr_param_all_quanti_dialog.ui
  ./gui/mcqr_run_view/mcqr_run_view.ui
  ./gui/mcqr_run_view/mcqr_sds_widget/mcqr_sds_widget.ui
  ./gui/mcqr_run_view/mcqr_sds_xic_widget/mcqr_sds_xic_widget.ui
  ./gui/main.ui
  ./gui/peptide_detail_view/peptide_detail_view.ui
  ./gui/peptide_list_view/peptide_view.ui
  ./gui/project_view/identification_group_widget/identification_group_widget.ui
  ./gui/project_view/project_view.ui
  ./gui/protein_list_view/protein_view.ui
  ./gui/protein_view/protein_detail_view.ui
  ./gui/ptm_island_list_view/ptm_island_list_view.ui
  ./gui/ptm_peptide_list_view/ptm_peptide_list_view.ui
  ./gui/tandem_run_dialog/tandem_run_dialog.ui
  ./gui/waiting_message_dialog/waiting_message_dialog.ui
  ./gui/widgets/automatic_filter_widget/automatic_filter_widget.ui
  ./gui/widgets/engines_view/xtandem_view_widget.ui
  ./gui/widgets/engines_view/no_engine_view_widget.ui
  ./gui/widgets/qcp_massdelta/qcpmassdelta.ui
  ./gui/widgets/contaminant_widget/contaminant_widget.ui
  ./gui/widgets/decoy_widget/decoy_widget.ui
  ./gui/xic_view/xic_box/xic_box.ui
  ./gui/xic_view/xic_widgets/zivy_widget.ui
  ./gui/xic_view/xic_widgets/xic_export_param.ui
  ./gui/xic_view/xic_window.ui
  )


# this will run uic on .ui files:
qt5_wrap_ui( GUI_UI_HDRS ${GUI_UIS} )


#message("XTPCPP_SRCS:  ${XTPCPP_SRCS}")




if(UNIX AND NOT APPLE)

  add_executable(${TARGET} main.cpp ${CPP_FILES} ${XTPCPP_SRCS} ${GUI_UI_HDRS} ${xtpcpp_RCC_SRCS})
  add_executable(tandemwrapper tandemwrapper.cpp)


elseif(APPLE)

  add_executable(${TARGET} main.cpp ${CPP_FILES} ${XTPCPP_SRCS} ${GUI_UI_HDRS} ${xtpcpp_RCC_SRCS}
    ${PLATFORM_SPECIFIC_SOURCES}
    ../src/resources/xtandempipeline_icon.icns
    )

  set_target_properties(${TARGET} PROPERTIES 
    MACOSX_BUNDLE_ICON_FILE xtandempipeline_icon.icns)

elseif(MXE)

  add_executable(xtpcpp main.cpp ${CPP_FILES} ${XTPCPP_SRCS} ${GUI_UI_HDRS} ${xtpcpp_RCC_SRCS})
  add_executable(tandemwrapper tandemwrapper.cpp)

  target_compile_options(${TARGET} PRIVATE -mwindows)
  set_target_properties(${TARGET} PROPERTIES LINK_FLAGS "-Wl,--subsystem,windows ${CMAKE_EXE_LINKER_FLAGS}")
  target_compile_options(tandemwrapper PRIVATE -mwindows)
  set_target_properties(tandemwrapper PROPERTIES LINK_FLAGS "-Wl,--subsystem,windows ${CMAKE_EXE_LINKER_FLAGS}")

endif()




target_link_libraries(tandemwrapper Qt5::Core Qt5::Xml PappsoMSpp::Core)

target_include_directories(${TARGET} PUBLIC
  ${Quazip5_INCLUDE_DIRS}
  ${QCustomPlot_INCLUDE_DIR}
  )

target_link_libraries(${TARGET}
  OdsStream::Core
  PappsoMSpp::Core
  PappsoMSpp::Widget
  Grantlee5::Templates
  RData::Core
  Qt5::Core
  Qt5::Gui
  Qt5::Xml
  Qt5::Svg
  Qt5::PrintSupport
  Qt5::Network
  Qt5::Sql
  Qt5::Concurrent
  ZLIB::ZLIB
  QCustomPlot::QCustomPlot
  ${Quazip5_LIBRARY}
  )




install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${TARGET} DESTINATION bin)

=== tests/CMakeLists.txt ===

message(\n${BoldRed}"Now configuring tests for ${CMAKE_PROJECT_NAME}"${ColourReset}\n)


configure_file (config.h.cmake ${CMAKE_SOURCE_DIR}/tests/config.h)

find_package(Catch2 REQUIRED)

find_package(Qt5 COMPONENTS Core Xml Gui Concurrent REQUIRED)


set(catch2_only_cpp_SRCS
    test_tandem_input.cpp
    test_condor_status.cpp
    ../src/input/mzidentml/msrunsaxhandler.cpp
    ../src/input/tandem/tandeminfoparser.cpp
    ../src/input/tandem/tandemparamparser.cpp
    ../src/core/tandem_run/tandemparameters.cpp
    ../src/core/condor_process/condorqueueparser.cpp
)

add_executable(catch2-only-tests
    ${catch2_only_cpp_SRCS}
)

target_link_libraries(catch2-only-tests
    Qt5::Core
    Qt5::Xml
    PappsoMSpp::Core
)

set_property(TARGET catch2-only-tests PROPERTY CXX_STANDARD 17) # we want C++17

  # Add the Catch2-based single binary test file to the CMake's test suite so
  # that it gets called using 'make test'. To see the output, add "ARGS=-V" to
  # the call.
add_test(catch2-only-tests "catch2-only-tests")

=== doc/sphinx/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  epub3      to make an epub3"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"
	@echo "  dummy      to check syntax errors of document sources"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/xtandempipeline.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/xtandempipeline.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/xtandempipeline"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/xtandempipeline"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: epub3
epub3:
	$(SPHINXBUILD) -b epub3 $(ALLSPHINXOPTS) $(BUILDDIR)/epub3
	@echo
	@echo "Build finished. The epub3 file is in $(BUILDDIR)/epub3."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

.PHONY: dummy
dummy:
	$(SPHINXBUILD) -b dummy $(ALLSPHINXOPTS) $(BUILDDIR)/dummy
	@echo
	@echo "Build finished. Dummy builder generates no files."

=== doc/user-manual/CMakeLists.txt ===
if(BUILD_USER_MANUAL)

  message("")
  message(STATUS "${BoldGreen}Starting configuration for the user manual for ${CMAKE_PROJECT_NAME} ${ColourReset}")
  message("")

  # The version of the program needs to be set in the user manual front
  # matter.
  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/user-manual-version-entity.ent.cmake.in
    ${CMAKE_SOURCE_DIR}/doc/user-manual/xml/user-manual-version-entity.ent @ONLY)

  # The location of the main user manual config file (set fop.xconf file
  # location)
  set(FOP_XCONF_DIR ${CMAKE_SOURCE_DIR}/doc/user-manual)
  CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/CMakeStuff/DC-user-manual.cmake.in
    ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual @ONLY)

    
    
  # Command to make ${CMAKE_PROJECT_NAME}-doc
  # Will generate HTML and PDF documentation in the build directory

  # Note that TARGET needs to be lowercase. Since we build the documentation
  # only on UNIX, that target is set in
  # CMakeStuff/toolchains/unix-toolchain.cmake.

  
  add_custom_target(html
    daps -d DC-user-manual --verbosity=3 html --static
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Building the user manual (HTML)" VERBATIM
    )
  message("\tBuild the user manual (HTML) with make html.")
    
  add_custom_target(pdf
    daps -d DC-user-manual --verbosity=3 pdf
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Building the user manual (PDF)" VERBATIM
    )
  message("\tBuild the user manual (PDF) with make pdf.")
    
  add_custom_target(${TARGET}-doc
    DEPENDS pdf html
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    COMMENT "Building the ${TARGET} documentation" VERBATIM
    )
  message("\tBuild the user manual (HTML and PDF) with make ${TARGET}-doc.")

  add_custom_command( TARGET pdf PRE_BUILD
        COMMAND ${CMAKE_COMMAND} -E touch
                ${CMAKE_SOURCE_DIR}/doc/user-manual/DC-user-manual
        COMMENT "Force the rebuild of the user manual")
                
  # Beware, need to use the RENAME clause !
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/user-manual_color_en.pdf
    DESTINATION share/doc/${CMAKE_PROJECT_NAME} RENAME ${TARGET}-doc.pdf)

  install(DIRECTORY 
    ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/html/user-manual/
    DESTINATION share/doc/${CMAKE_PROJECT_NAME}/html)

  message("")
  message(STATUS "${BoldGreen}Finished configuring the ${CMAKE_PROJECT_NAME} user manual.${ColourReset}")
  message("")
  
  add_custom_target(wdoc DEPENDS pdf COMMENT "wdoc target copies the user manual into the wbuild directory (needed for Windows innosetup)")
  add_custom_command( TARGET wdoc POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy
                ${CMAKE_CURRENT_SOURCE_DIR}/build/user-manual/user-manual_color_en.pdf
                ${CMAKE_SOURCE_DIR}/wbuild/xtpcpp_user_manual.pdf)


else()

  message(STATUS "User manual build skipped")

endif()

=== doc/user-manual/Makefile ===
project=xtpcpp

topDir=$(CURDIR)

okularPid=${topDir}/okular.pid

pdfFilePath=${topDir}/build/user-manual
pdfFilePathName=${pdfFilePath}/user-manual_color_en.pdf 
htmlDirPath=${topDir}/build/user-manual/html/${project}-user-manual

default: pdf_r
#default: html_f_r pdf_f_r

all: pdf html

all_f: pdf_f html_f

all_f_r: pdf_f_r html_f_r

.PHONY: reader
reader:
	okular --geometry 1268x1099-0-34 $(pdfFilePathName) & echo $$! > okular.pid

# Make the pdf file without forcing without reload
pdf:
	daps -d ${topDir}/DC-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Make the pdf file with forcing remaking all the targets and without reload
pdf_f:
	daps --force -d ${topDir}/DC-user-manual --verbosity=3 pdf
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_r: pdf
	(cd ${topDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

# Reload with okular variant
pdf_f_r: pdf_f
	(cd ${topDir} && qdbus org.kde.okular-$(shell cat ${okularPid}) /okular reload)
	cp -fv ${pdfFilePathName} ${pdfFilePath}/${project}-doc.pdf
	cp -fv ${pdfFilePathName} ${topDir}/${project}-doc.pdf

html:
	daps -d ${topDir}/DC-user-manual --verbosity=3 html --static

html_f: html
	daps --force -d ${topDir}/DC-user-manual --verbosity=3 html --static

html_r: html
	firefox-reload-page.sh

html_f_r: html_f
	firefox-reload-page.sh

package_html:
	daps -d ${topDir}/DC-user-manual package-html

check_dir:
	echo "mkfile_path: $(mkfile_path)"
	echo "current_dir: $(current_dir)"	

	if [ -d "xml" ];\
	 	then \
		echo "Not in a user manual top source directory.";\
		exit 1;\
		fi

=== debian/changelog ===
xtpcpp (0.4.51-1) unstable; urgency=medium

  * New upstream release now building on top of libpappsomspp 0.8.48 (Closes:
    #1005151, thanks to Adrian Bunk <bunk@debian.org>).

  [ Filippo Rusconi ]

  * betterment of the whole manual
  * rename the binary package from tandemwrapper to xtpcpp-tandemwrapper

  [ Olivier Langella ]

  * replacement of old sax based XML parsers for tandem presets and HTCondor
  * new test on XML parsers
  * new formula column added in the peptide ODS output

 -- Filippo Rusconi <lopippo@debian.org>  Wed, 09 Feb 2022 15:33:40 +0100

xtpcpp (0.4.49-1~bullseye1) bullseye; urgency=medium

  [ Olivier Langella ]
  * gui label fix
  * duplicated xml group ids in proticdbml fixed thanks to Kevin ROGER <kevin.roger@inserm.fr>
  [ Filippo Rusconi ]
  * going forward with the user manual, almost done

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 13 Jan 2022 09:32:56 +0100

xtpcpp (0.4.48-1~bullseye1) bullseye; urgency=medium

  * fix XIC reextract bug

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 11 Jan 2022 09:31:29 +0100

xtpcpp (0.4.47-1~bullseye1) bullseye; urgency=medium

  * refactoring MCQ settings for timsTOF
  * select R binary path in preferences
  * fix grantlee plugin problem for win64 installation thanks to Kevin ROGER <kevin.roger@inserm.fr>

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 07 Jan 2022 09:12:11 +0100

xtpcpp (0.4.46-1~bullseye2) bullseye; urgency=medium

  * fix mess between xtpcpp and tandemwrapper install instructions

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 03 Jan 2022 11:07:56 +0100

xtpcpp (0.4.46-1~bullseye1) bullseye; urgency=medium

  [ Olivier Langella ]
  * tandemwrapper added to xtpcpp distribution
  * new tandem parser, fix for tdf sample name
  * remove quantile filter integration for timsTOF pro
  * lots of fix to integrate R process into xtpcpp: basic XIC analysis
  available in production
  [ Filippo Rusconi ]
  * going forward with the user manual

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 03 Jan 2022 09:26:54 +0100

xtpcpp (0.4.45-1~bullseye1) bullseye; urgency=medium

  [ Olivier Langella ]
  * display ion sequence in peptide detail status bar
  [ Filippo Rusconi ]
  * going forward with the user manual

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 21 Dec 2021 08:56:40 +0100

xtpcpp (0.4.44-1~bullseye1) bullseye; urgency=medium

  [ Olivier Langella ]
  * fix fragment ion tags bearing phospho acid loss
  [ Filippo Rusconi ]
  * going forward with the user manual (phophoproteomics)

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 16 Dec 2021 13:25:05 +0100

xtpcpp (0.4.43-2~bullseye1) bullseye; urgency=medium

  * new libpappsomspp library

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sat, 11 Dec 2021 16:29:18 +0100

xtpcpp (0.4.43-1~bullseye1) bullseye; urgency=medium

  * new package for bullseye

 -- Olivier Langella <olivier.langella@u-psud.fr>  Fri, 26 Nov 2021 15:08:12 +0100

=== debian/control ===
Source: xtpcpp
Section: science
Priority: optional
Maintainer: The Debichem Group <debichem-devel@alioth-lists.debian.net>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 12),
 dpkg-dev (>= 1.18.25),
 cmake (>= 3.12),
 qtbase5-dev,
 libpappsomspp-dev (>= 0.8.48),
 libpappsomspp-widget-dev (>= 0.8.48),
 libodsstream-dev,
 libqt5svg5-dev,
 libqcustomplot-dev,
 libgrantlee5-dev,
 librdata-dev (>= 0~20210223+git-85757dc6),
 docbook-to-man,
 libjs-jquery,
 libjs-highlight.js,
 daps,
 fonts-ebgaramond,
 fonts-ebgaramond-extra,
 doxygen,
 catch2,
 graphviz
Standards-Version: 4.6.0
Homepage: http://pappso.inra.fr/bioinfo

Package: xtpcpp
Architecture: any
Multi-Arch: no
Depends: ${shlibs:Depends},
 ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: C++ version of X!TandemPipeline
 The program allows one to perform the following tasks:
  -Reads X!Tandem xml results files
  -Reads MASCOT dat results files
  -Reads TPP pepXML results files
  -Reads PSI mzIdentML results files
  -Run X!Tandem analyzes through a graphical user interface
  -Implements various filters based on statistical values
  -Powerful original grouping algorithm to filter redundancy
  -Phosphopeptide mode to handle phosphoproteomics datasets
  -Edit, search and sort the data graphically
  -XIC chromatogram browser (eXtracted Ion Current)
  -Comparisons of theoretical isotope patterns to measured MS1 XIC areas
  -Export data directly to Microsoft Office 2010 and LibreOffice (ods export)
  -Handle huge datasets very quickly
  -Perform peptide quantification through MassChroQml export

Package: xtpcpp-doc
Section: doc
Architecture: all
Depends: libjs-jquery,
         libjs-highlight.js,
         ${misc:Depends}
Description: C++ version of X!TandemPipeline (user manual)
 The program allows one to perform the following tasks:
  -Reads X!Tandem xml results files
  -Reads MASCOT dat results files
  -Reads TPP pepXML results files
  -Reads PSI mzIdentML results files
  -Run X!Tandem analyzes through a graphical user interface
  -Implements various filters based on statistical values
  -Powerful original grouping algorithm to filter redundancy
  -Phosphopeptide mode to handle phosphoproteomics datasets
  -Edit, search and sort the data graphically
  -XIC chromatogram browser (eXtracted Ion Current)
  -Comparisons of theoretical isotope patterns to measured MS1 XIC areas
  -Export data directly to Microsoft Office 2010 and LibreOffice (ods export)
  -Handle huge datasets very quickly
  -Perform peptide quantification through MassChroQml export
 .
 This package ships the user manual in both PDF and HTML formats.

Package: xtpcpp-tandemwrapper
Architecture: any
Multi-Arch: no
Depends: ${shlibs:Depends},
 ${misc:Depends},
 tandem-mass
Pre-Depends: ${misc:Pre-Depends}
Description: X!Tandem wrapper for timsTOF pro and modern mzML data
 Allows using transparently the X!Tandem database search engine 
 originally developped at https://www.thegpm.org/TANDEM/
 on timsTOF pro raw data or any other standard format not yet 
 handled natively by X!Tandem.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=Release \
		-DBUILD_TESTING=0 \
		-DCMAKE_SKIP_RPATH=1 \
		-DBUILD_USER_MANUAL=1
		
override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- xtpcpp-doc

=== debian/watch ===
version=4

# The following page lists the releases
#
# https://forgemia.inra.fr/pappso/xtpcpp/-/tags
#
# And the actual href in the page is
#
# href="/pappso/xtpcpp/-/archive/0.4.26/xtpcpp-0.4.42.tar.gz"
#

https://forgemia.inra.fr/pappso/xtpcpp/-/tags \
  .*/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
